#!/bin/sh
. `dirname $0`/../func.sh

init_dev
[ $? -ne 0 ] && exit 1

guess_param

echo 0 > /sys/class/graphics/fbcon/cursor_blink

echo "select resolution"
echo "================="
echo "1 = 2592 x 1944 Full"
echo "2 = 1296 x 972  skip2 & binning"
echo "3 = 864  x 648  skip3"
echo "4 = 648  x 486  skip4 & binning"
echo "5 = 432  x 324  skip6 & binning"

read RESOLUTION
echo "Your select = $RESOLUTION"
case $RESOLUTION in
  "1") FRAME_SIZE=",width=2592,height=1944";;
  "2") FRAME_SIZE=",width=1296,height=972";;
  "3") FRAME_SIZE=",width=864,height=648";;
  "4") FRAME_SIZE=",width=648,height=486";;
  "5") FRAME_SIZE=",width=432,height=324";;
  *) FRAME_SIZE=",width=648,height=486";;
esac

echo "==============================================================="
echo "starting gstreamer with monochrome Source ..."
echo "read $FRAME_SIZE convert and write scaled to framebuffer 640x480"
echo "==============================================================================="


echo ""
echo " configure camera with v4l2_control"
echo " =================================="

EXPOSURE_VAL=${FRAME_SIZE##*=}
GAIN_VAL=$(( 15552 / EXPOSURE_VAL ))
echo " Exposure = $EXPOSURE_VAL (For max. fps we recommend exposure <= rows.)"
echo " Gain = $GAIN_VAL (Used gain depends on the lighting, the aperture value and exposure.)"
v4l2-ctl -d $CAM_DEVICE -c exposure=$EXPOSURE_VAL
v4l2-ctl -d $CAM_DEVICE -c gain=$GAIN_VAL

# ./../tools/cam_regs.sh -s subdev0 -r ./../$REG_SET_FILE
# Use the "cam_regs.sh" tool, only for special register settings, that are not available through v4l2_control.

echo ""
echo "start gstreamer, break with ctl-C"
echo "================================="

gst-launch-1.0 \
	v4l2src device=$CAM_DEVICE ! \
	video/x-raw,format=GRAY8,depth=8$FRAME_SIZE ! \
	videoconvert ! video/x-raw$FRAME_SIZE ! \
	videoscale ! video/x-raw,width=640,height=480 ! \
	fbdevsink sync=false

echo 1 > /sys/class/graphics/fbcon/cursor_blink